/// @cond EO_CXX_EO_IMPL

inline void elm::route::emap_set(void * emap_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_route_emap_set(emap_));
}

inline void elm::route::longitude_min_max_get(double* min_, double* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_route_longitude_min_max_get(min_, max_));
}

inline void elm::route::latitude_min_max_get(double* min_, double* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_route_latitude_min_max_get(min_, max_));
}

inline void eo_cxx::elm::route::emap_set(void * emap_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_route_emap_set(emap_));
}

inline void eo_cxx::elm::route::longitude_min_max_get(double* min_, double* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_route_longitude_min_max_get(min_, max_));
}

inline void eo_cxx::elm::route::latitude_min_max_get(double* min_, double* max_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_route_latitude_min_max_get(min_, max_));
}

inline ::eo_cxx::elm::route::operator ::elm::route() const
{
   return *static_cast<::elm::route const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::route::operator ::elm::route&()
{
   return *static_cast<::elm::route*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::route::operator ::elm::route const&() const
{
   return *static_cast<::elm::route const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_route_emap_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, void * emap_)
{
   try
      {
         static_cast<T*>(self->this_)->emap_set(emap_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_route_longitude_min_max_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* min_, double* max_)
{
   try
      {
         static_cast<T*>(self->this_)->longitude_min_max_get(min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_route_latitude_min_max_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* min_, double* max_)
{
   try
      {
         static_cast<T*>(self->this_)->latitude_min_max_get(min_, max_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::route >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
   {
      virtual void emap_set(void * emap_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_route_emap_set(emap_));
      }

      virtual void longitude_min_max_get(double* min_, double* max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_route_longitude_min_max_get(min_, max_));
      }

      virtual void latitude_min_max_get(double* min_, double* max_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_route_latitude_min_max_get(min_, max_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::route >
{
   static constexpr int value = 
#if defined(ROUTE_PROTECTED) && defined(ROUTE_BETA)
      3
#elif defined(ROUTE_PROTECTED)
      3
#elif defined(ROUTE_BETA)
      3
#else
      3
#endif
      + operation_description_class_size<::elm::widget >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::route>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_route_emap_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_route_emap_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_route_longitude_min_max_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_route_longitude_min_max_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_route_latitude_min_max_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_route_latitude_min_max_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::route >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::route>)
{
   return (ELM_ROUTE_CLASS);
}

} } }

/// @endcond

